#ifndef __TRANSPORT_H__
#define __TRANSPORT_H__

#include <stdio.h>

typedef enum
{
  NONE,
  READ,
  WRITE
} Direction;

typedef struct _Scsi_Command Scsi_Command;

Scsi_Command *  scsi_command_new           (void);
Scsi_Command *  scsi_command_new_from_fd   (int fd);
void            scsi_command_free          (Scsi_Command  *cmd);

unsigned char * scsi_command_sense         (Scsi_Command  *cmd);
int             scsi_command_associate     (Scsi_Command  *cmd,
                                            const char    *file);
void            scsi_command_set           (Scsi_Command  *cmd,
                                            size_t        index,
                                            unsigned char value);
int             scsi_command_transport     (Scsi_Command  *cmd,
                                            Direction     dir,
                                            void          *buf,
                                            size_t        sz);
int             scsi_command_wait_for_unit (Scsi_Command  *cmd,
                                            volatile int  *progress);

#endif /* __TRANSPORT_H__ */

